//
//  OPAppLinks.h
//  ApplicationFrameworks
//
//  Created by Nathan Van Fleet on 2015-03-20.
//
//

#import <Foundation/Foundation.h>

// Links are not universally programmed on the redirect server
// So some programmings are on both platforms, some not

// MAC ONLY
// =============
// User Guide
extern NSString * const OPUserGuideJSE3Uninstall;
extern NSString * const OPUserGuideFrequentlyAskedQuestions;
extern NSString * const OPUserGuideSetupExistingAnotherDevice;
extern NSString * const OPUserGuideBrowserValidationFailed;
extern NSString * const OPUserGuideBrowserExtensionAuthFail;
extern NSString * const OPUserGuideTroubleshootingUtility;
extern NSString * const OPUserGuideiCloudWebStoreFrequentlyAskedQuestions;
extern NSString * const OPUserGuideiCloudFrequentlyAskedQuestions;
extern NSString * const OPUserGuideiCloudEnableInSystemPreferences;
extern NSString * const OPUserGuideCannotConnectToMini;
extern NSString * const OPUserGuideCannotConnectToMiniQuarantine;
extern NSString * const OPUserGuideLaunchedIncorrectMini;
extern NSString * const OPUserGuideSyncToNetworkVolume;
extern NSString * const OPUserGuideLicenseFileFAQ;
extern NSString * const OPUserGuideAboutLicenses;
extern NSString * const OPUserGuideAppleLegalInternetServices;
extern NSString * const OPUserGuideWiFiSync;
extern NSString * const OPUserGuideUpdaterMultipleApps;
extern NSString * const OPUserGuideSetupSync;
extern NSString * const OPUserGuideNewComputer;
extern NSString * const OPUserGuideMacTouchIDSecurity;

extern NSString * const OPUserGuideAddTeamsAccount;
extern NSString * const OPAppLinkTeamsWelcome;
extern NSString * const OPAppLinkFamiliesWelcome;

extern NSString * const OPAppLinkTeamsGetTheApps;
extern NSString * const OPAppLink1PasswordDotCom;
extern NSString * const OPAppLinkTeamChangePassword;

extern NSString * const OPAppLinkWelcome;
extern NSString * const OPAppLinkFirstRunVideo;
extern NSString * const OPAppLinkInstallExtension;
extern NSString * const OPAppLinkBuyNow;
extern NSString * const OPAppLinkLicenses;
extern NSString * const OPAppLinkOnePassword;
extern NSString * const OPAppLinkOPXSMAAuthMoreInformation;

// Release Notes
extern NSString * const OPAppLinkReleaseNotes;
extern NSString * const OPAppLinkReleaseNotesBeta;
extern NSString * const OPAppLinkReleaseNotesWebStore;
extern NSString * const OPAppLinkReleaseNotesAppStore;

// IOS ONLY
// =============
extern NSString * const OPUserGuideKnowledgebase;

// Link to Apple Watch KB article
extern NSString * const OPKnowledgeBaseAppleWatchSetup;

// Link to Import KB article
extern NSString * const OPKnowledgeBaseImportInstructions;

// Troubleshooting
extern NSString * const OPUserGuideTroubleshootingSetupExistingUserCloudKitDataNotFound;
extern NSString * const OPUserGuideTroubleshootingEnableCloudKitInDeviceSettings;
extern NSString * const OPUserGuideTroubleshootingCloudKitRequirements;

// MAC & IOS
// =============
extern NSString * const OPUserGuideIndex;
extern NSString * const OPUserGuideDiscussionForums;
extern NSString * const OPAppLinkNewsLetterSignup;
extern NSString * const OPAppLinkContactSupport;
extern NSString * const OPAppLinkAccountDetailsInfo;

// App Store Share - Sharing link when you email a link
extern NSString * const OPAppLinkShareAppFromSharedItem;

// App Store Share - Sharing from the Settings Page
extern NSString * const OPAppLinkShareAppFromSettings;

// App Store - Required update to client through App Store
extern NSString * const OPAppLinkAppStoreRequiredUpdate;

// Touch ID Security Article
extern NSString * const OPAppLinkAboutTouchIDSecurity;

// B5
// ===============
extern NSString * const B5UserAccountReauthWindow;
extern NSString * const B5UserAccountSuspended;
extern NSString * const B5AppLinkLearnMoreAboutTeams;
extern NSString * const B5UserAccountFrozen;
extern NSString * const B5UserAccountManageBilling;

@interface OPAppLinks : NSObject

+ (NSURL*)URLForPage:(NSString *)page;

+ (NSString *)URLStringForPage:(NSString *)page;

@end
