//
//  OPAppStoreInAppPurchase.h
//  ApplicationFrameworks
//
//  Created by Roustem Karimov on 2014-07-25.
//
//

#import <Foundation/Foundation.h>

@interface OPAppStoreInAppPurchase : NSObject

- (instancetype)initWithDictionary:(NSDictionary *)dictionary;

@property (nonatomic, readonly) NSInteger quantity;

@property (nonatomic, readonly) NSString *productIdentifier;
@property (nonatomic, readonly) NSString *purchaseDate;
@property (nonatomic, readonly) NSString *originalPurchaseDate;
@property (nonatomic, readonly) NSString *cancellationDate; // [Roo, 2016-10-13] For a transaction that was canceled by Apple customer support, the time and date of the cancellation. Treat a canceled receipt the same as if no purchase had ever been made.
@property (nonatomic, readonly) NSString *subscriptionExpirationDateString; // [Roo, 2016-10-13] This value is only present for auto-renewing subscriptions.

@property (nonatomic, readonly) NSDate *subscriptionExpirationDate;

@property (nonatomic, readonly, getter=isPurchased) BOOL purchased;
@property (nonatomic, readonly, getter=isSubscription) BOOL subscription;

@end
