//
//  OPPublicKey.h
//  ApplicationFrameworks
//
//  Created by Roustem Karimov on 2015-03-19.
//
//

#import <Foundation/Foundation.h>

FOUNDATION_EXPORT NSString * const OPRSAKeyType;

FOUNDATION_EXPORT NSString * const OPRSAKeyAttrE;
FOUNDATION_EXPORT NSString * const OPRSAKeyAttrN;

FOUNDATION_EXPORT const int RSA_PADDING;

@interface OPPublicKey : NSObject

@property (nonatomic, strong) NSString *kid;
@property (nonatomic, readonly, copy) NSString *alg;

- (id)initWithJSON:(NSDictionary *)json;

- (int)padding;
- (NSDictionary *)exportAsJSON;

- (NSDictionary *)encrypt:(NSData *)plaintext error:(NSError **)error;

@end

