//
//  B5MasterUserAccountUnlockProfile.h
//  ApplicationFrameworks
//
//  Created by Rick Fillion on 10/6/15.
//
//

#import <Foundation/Foundation.h>
#import "OPGenericProfile.h"

@class B5UserAccount;

@interface B5MasterUnlockProfile : NSObject <OPGenericProfile, NSSecureCoding>

+ (NSString *)profileUUID;

- (instancetype)initWithMasterUserAccount:(B5UserAccount *)userAccount;

@property (nonatomic, readonly, strong) B5UserAccount *masterUserAccount;

- (BOOL)unlockWithPassword:(NSString *)password;
- (BOOL)unlockWithLoginDictionary:(NSDictionary *)accountLoginDictionary;
- (NSArray *)unlockUserAccounts:(NSArray *)userAccounts; // Returns array of all user accounts successfully unlocked

@end
