//
//  OPOTPConstants.h
//  ApplicationFrameworks
//
//  Created by Michael Fey on 2/12/15.
//
//

#import <OnePasswordCore/OnePasswordCore.h>

// Parent App Messaging
NSSTRING_CONST_EXTERN(OPWatchSyncUpdateItemKey);
NSSTRING_CONST_EXTERN(OPWatchSyncDeleteItemKey);
NSSTRING_CONST_EXTERN(OPWatchSyncClearKeychainKey);

// Notifications
NSSTRING_CONST_EXTERN(OPWatchDisabledForLegacyPINCodeNotification);

// Item Types
NSSTRING_CONST_EXTERN(OPWatchTypeKey);
NSSTRING_CONST_EXTERN(OPWatchTypeOTP);
NSSTRING_CONST_EXTERN(OPWatchTypeLogin);
NSSTRING_CONST_EXTERN(OPWatchTypePassword);
NSSTRING_CONST_EXTERN(OPWatchTypeCreditCard);
NSSTRING_CONST_EXTERN(OPWatchTypeSecureNote);
NSSTRING_CONST_EXTERN(OPWatchTypePassport);
NSSTRING_CONST_EXTERN(OPWatchTypeSocialSecurityNumber);
NSSTRING_CONST_EXTERN(OPWatchTypeDriversLicense);
NSSTRING_CONST_EXTERN(OPWatchTypeWirelessRouter);
NSSTRING_CONST_EXTERN(OPWatchTypeBankAccount);

// Login (and Password) Keys
NSSTRING_CONST_EXTERN(OPWatchLoginItemUsernameKey);
NSSTRING_CONST_EXTERN(OPWatchLoginItemPasswordKey);

// Secure Note Keys
NSSTRING_CONST_EXTERN(OPWatchSecureNoteItemNoteKey);

// Credit Card Keys
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemNumberKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemExpiryDateKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemVerificationNumberKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemTypeKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemPINKey);

NSSTRING_CONST_EXTERN(OPWatchCreditCardItemTypeVisaKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemTypeAmericanExpressKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemTypeMasterCardKey);
NSSTRING_CONST_EXTERN(OPWatchCreditCardItemTypeDiscoverKey);

NSSTRING_CONST_EXTERN(OPOTPKeychainService);
NSSTRING_CONST_EXTERN(OPWatchKeychainItemValueDataKey);
NSSTRING_CONST_EXTERN(OPOTPKeychainItemUUIDKey);
NSSTRING_CONST_EXTERN(OPOTPKeychainItemNameKey);
NSSTRING_CONST_EXTERN(OPOTPKeychainItemURLKey);
NSSTRING_CONST_EXTERN(OPOTPKeychainItemOTPSecretKey);

// Passport Keys
NSSTRING_CONST_EXTERN(OPWatchPassportItemTypeKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemIssueDateKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemExpiryDateKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemBirthDateKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemNumberKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemIssuingCountryKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemFullNameKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemSexKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemNationalityKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemIssuingAuthorityKey);
NSSTRING_CONST_EXTERN(OPWatchPassportItemBirthplaceKey);

// SSN Keys
NSSTRING_CONST_EXTERN(OPWatchSocialSecurityNumberItemNameKey);
NSSTRING_CONST_EXTERN(OPWatchSocialSecurityNumberItemNumberKey);

// Driver's License Keys
NSSTRING_CONST_EXTERN(OPWatchDriversLicenseItemNameKey);
NSSTRING_CONST_EXTERN(OPWatchDriversLicenseItemNumberKey);
NSSTRING_CONST_EXTERN(OPWatchDriversLicenseItemExpiryKey);

// Wireless Router Keys
NSSTRING_CONST_EXTERN(OPWatchWirelessRouterItemNameKey);
NSSTRING_CONST_EXTERN(OPWatchWirelessRouterItemSSIDKey);
NSSTRING_CONST_EXTERN(OPWatchWirelessRouterItemPasswordKey);
NSSTRING_CONST_EXTERN(OPWatchWirelessRouterItemAdminPasswordKey);
NSSTRING_CONST_EXTERN(OPWatchWirelessRouterItemSecurityTypeKey);

// Bank Account Keys
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemBankNameKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemOwnerKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemTypeKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemRoutingNumberKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemAccountNumberKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemSwiftKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemIBANKey);
NSSTRING_CONST_EXTERN(OPWatchBankAccountItemTelephonePINKey);
